module Turing1 where

-- Turingmaschine erhht Dualzahl um 1, leeres Band --> Ergebnis 1
-- berfhrungsfunktion tinc1 nach gelbem Heft Seite 9 Aufgabe 1

inc1 :: [Char] -> [Char]
inc1 s = tinc1 (['*']++s++['*']) 1 0	--Bandbeschriftung Bandposition Zustand

-- tinc1 :: Bandbeschriftung Bandposition Folgezustand

tinc1 :: [Char] -> Int -> Int -> [Char]
tinc1 s b z
	|b<0 = error "Fehler"
	|z==0 && ein=='0' = tinc1 s (b+1) 0
	|z==0 && ein=='1' = tinc1 s (b+1) 0
	|z==0 && ein=='*' = tinc1 s (b-1) 1
	|z==1 && ein=='0' = tinc1 (schreibe s b '1') b 2
	|z==1 && ein=='1' = tinc1 (schreibe s b '0') (b-1) 1
	|z==1 && ein=='*' = tinc1 (schreibe s b '1') b 3
	|z==2 && ein=='0' = tinc1 s (b-1) 2
	|z==2 && ein=='1' = tinc1 s (b-1) 2
	|z==2 && ein=='*' = tinc1 s (b+1) 3
	|z==3 && b==1 = tail (init s) -- erstes und letztes '*' abschneiden
	|z==3 && b==0 = init s        -- letztes '*' abschneiden
	|otherwise = error "Falsches Eingabezeichen!"
	where ein = head (drop b s)
	
-- schreibe :: esetzt im String s das Zeichen an der Bandposition durch das angegebene Zeichen
-- schreibe :: String Bandposition Zeichen

schreibe :: [Char] -> Int -> Char -> [Char]
schreibe "" b c = ""
schreibe s b c = take b s++[c]++tail (drop b s)

-- take 3 "*11101*" --> "*11" die ersten drei Zeichen
-- drop 3 "*11101*" --> "101*" die Liste ohne die ersten drei Zeichen

testinc1 :: [[Char]] -> [[Char]]
testinc1 [] = []
testinc1 (x:xs) = inc1 x:testinc1 xs

test :: [[Char]]
test = testinc1 ["","0","1","10","11","100","101","110","111"]