module TuringSort where

-- Turingmaschine sortiert 0 und 1 innerhalb einer Dualzahl
-- Prfungsaufgabe im Abitur 2008

sort :: [Char] -> [Char]
sort s = sort1 (['*']++s++['*']) 1 0	-- Bandbeschriftung Bandposition Zustand

-- sort1 :: Bandbeschriftung Bandposition Folgezustand

sort1 :: [Char] -> Int -> Int -> [Char]
sort1 s b z
	|b<0 = error "Fehler"
	|z==0 && ein=='0' = sort1 s (b+1) 1
	|z==0 && ein=='1' = sort1 s (b+1) 2
	|z==0 && ein=='*' = sort1 s b 6
	|z==1 && ein=='0' = sort1 s (b+1) 1
	|z==1 && ein=='1' = sort1 s (b+1) 2
	|z==1 && ein=='*' = sort1 s (b-1) 5
	|z==2 && ein=='0' = sort1 (schreibe s b '1') (b-1) 3
	|z==2 && ein=='1' = sort1 s (b+1) 2
	|z==2 && ein=='*' = sort1 s (b-1) 5
	|z==3 && ein=='0' = sort1 s b 3
	|z==3 && ein=='1' = sort1 (schreibe s b '0') b 4
	|z==3 && ein=='*' = sort1 s b 3
	|z==4 && ein=='0' = sort1 s (b-1) 4
	|z==4 && ein=='1' = sort1 s (b-1) 4
	|z==4 && ein=='*' = sort1 s (b+1) 0
	|z==5 && ein=='0' = sort1 s (b-1) 5
	|z==5 && ein=='1' = sort1 s (b-1) 5
	|z==5 && ein=='*' = sort1 s (b+1) 6
	|z==6 = tail (init s)               -- erstes und letztes '*' abschneiden
	|otherwise = error "Falsches Eingabezeichen!"
	where ein = head (drop b s)
	
-- schreibe :: ersetzt im String s das Zeichen an der Bandposition durch das angegebene Zeichen
-- schreibe :: String Bandposition Zeichen

schreibe :: [Char] -> Int -> Char -> [Char]
schreibe "" b c = ""
schreibe s b c = take b s++[c]++tail (drop b s)

-- take 3 "*11101*" --> "*11" die ersten drei Zeichen
-- drop 3 "*11101*" --> "101*" die Liste ohne die ersten drei Zeichen

testsort :: [[Char]] -> [[Char]]
testsort [] = []
testsort (x:xs) = sort x:testsort xs

test :: [[Char]]
test = testsort ["","0","1","01","10","11","100","101","110","111","1101","0101"]